-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- Counter circuit
-----------------------------------------------------------
-- File   : count_vhdl_top.vhd
-- Date   : 2007-08-17
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity count_vhdl_top is
	port(
		CLK		:	in std_logic;
		LED1A	:	out std_logic;
		LED1B	:	out std_logic;
		LED1C	:	out std_logic;
		LED1D	:	out std_logic;
		LED1E	:	out std_logic;
		LED1F	:	out std_logic;
		LED1G	:	out std_logic;
		LED1DP	:	out std_logic;
		LED2A	:	out std_logic;
		LED2B	:	out std_logic;
		LED2C	:	out std_logic;
		LED2D	:	out std_logic;
		LED2E	:	out std_logic;
		LED2F	:	out std_logic;
		LED2G	:	out std_logic;
		LED2DP	:	out std_logic
	);
end count_vhdl_top;

architecture RTL of count_vhdl_top is

	signal counter	:	std_logic_vector(7 downto 0);
	signal div_cnt	:	std_logic_vector(31 downto 0);
	signal div_clk	:	std_logic;
	signal led1		:	std_logic_vector(7 downto 0);
	signal led2		:	std_logic_vector(7 downto 0);

begin

	process(CLK)
	begin
		if(CLK'event and CLK='1') then
			div_cnt <= div_cnt + 1;
		end if;
	end process;
	div_clk <= div_cnt(22);
	
	process(div_clk)
	begin
		if(div_clk'event and div_clk='1') then
			counter <= counter + 1;
		end if;
	end process;

	process(counter)
	begin
		case counter(7 downto 4) is
			when "0000" =>
				led2 <= "00111111";
			when "0001" =>
				led2 <= "00000110";
			when "0010" =>
				led2 <= "01011011";
			when "0011" =>
				led2 <= "01001111";
			when "0100" =>
				led2 <= "01100110";
			when "0101" =>
				led2 <= "01101101";
			when "0110" =>
				led2 <= "01111101";
			when "0111" =>
				led2 <= "00000111";
			when "1000" =>
				led2 <= "01111111";
			when "1001" =>
				led2 <= "01101111";
			when "1010" =>
				led2 <= "01110111";
			when "1011" =>
				led2 <= "01111100";
			when "1100" =>
				led2 <= "00111001";
			when "1101" =>
				led2 <= "01011110";
			when "1110" =>
				led2 <= "01111001";
			when "1111" =>
				led2 <= "01110001";
			when others =>
				led2 <= "00000000";
		end case;
		case counter(3 downto 0) is
			when "0000" =>
				led1 <= "00111111";
			when "0001" =>
				led1 <= "00000110";
			when "0010" =>
				led1 <= "01011011";
			when "0011" =>
				led1 <= "01001111";
			when "0100" =>
				led1 <= "01100110";
			when "0101" =>
				led1 <= "01101101";
			when "0110" =>
				led1 <= "01111101";
			when "0111" =>
				led1 <= "00000111";
			when "1000" =>
				led1 <= "01111111";
			when "1001" =>
				led1 <= "01101111";
			when "1010" =>
				led1 <= "01110111";
			when "1011" =>
				led1 <= "01111100";
			when "1100" =>
				led1 <= "00111001";
			when "1101" =>
				led1 <= "01011110";
			when "1110" =>
				led1 <= "01111001";
			when "1111" =>
				led1 <= "01110001";
			when others =>
				led1 <= "00000000";
		end case;
	end process;

	LED1A  <= led1(0);
	LED1B  <= led1(1);
	LED1C  <= led1(2);
	LED1D  <= led1(3);
	LED1E  <= led1(4);
	LED1F  <= led1(5);
	LED1G  <= led1(6);
	LED1DP <= led1(7);
	LED2A  <= led2(0);
	LED2B  <= led2(1);
	LED2C  <= led2(2);
	LED2D  <= led2(3);
	LED2E  <= led2(4);
	LED2F  <= led2(5);
	LED2G  <= led2(6);
	LED2DP <= led2(7);
	
end RTL;
