-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- 2 Line Input to 4 Line Output Decoder Circuit
-----------------------------------------------------------
-- File   : decode_2to4_vhdl_top.vhd
-- Date   : 2009-06-04
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity decode_2to4_vhdl_top is
	port(
		LED_1	:	out std_logic;
		LED_2	:	out std_logic;
		LED_3	:	out std_logic;
		LED_4	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end decode_2to4_vhdl_top;

architecture RTL of decode_2to4_vhdl_top is

	signal A0	:	std_logic;
	signal A1	:	std_logic;
	signal EN	:	std_logic;
	signal Y0	:	std_logic;
	signal Y1	:	std_logic;
	signal Y2	:	std_logic;
	signal Y3	:	std_logic;

begin

	A0 <= not SW5;
	A1 <= not SW6;
	EN <= not SW7;

	Y0 <= EN and not A0 and not A1;
	Y1 <= EN and     A0 and not A1;
	Y2 <= EN and not A0 and     A1;
	Y3 <= EN and     A0 and     A1;

	LED_1 <= Y0;
	LED_2 <= Y1;
	LED_3 <= Y2;
	LED_4 <= Y3;
	
end RTL;
