-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- 3 Line Input to 8 Line Output Decoder Circuit
-----------------------------------------------------------
-- File   : decode_3to8_vhdl_top.vhd
-- Date   : 2009-06-04
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity decode_3to8_vhdl_top is
	port(
		LED_1	:	out std_logic;
		LED_2	:	out std_logic;
		LED_3	:	out std_logic;
		LED_4	:	out std_logic;
		LED_5	:	out std_logic;
		LED_6	:	out std_logic;
		LED_7	:	out std_logic;
		LED_8	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end decode_3to8_vhdl_top;

architecture RTL of decode_3to8_vhdl_top is

	signal A0	:	std_logic;
	signal A1	:	std_logic;
	signal A2	:	std_logic;
	signal Y0	:	std_logic;
	signal Y1	:	std_logic;
	signal Y2	:	std_logic;
	signal Y3	:	std_logic;
	signal Y4	:	std_logic;
	signal Y5	:	std_logic;
	signal Y6	:	std_logic;
	signal Y7	:	std_logic;

begin

	A0 <= not SW5;
	A1 <= not SW6;
	A2 <= not SW7;

	Y0 <= not A0 and not A1 and not A2;
	Y1 <=     A0 and not A1 and not A2;
	Y2 <= not A0 and     A1 and not A2;
	Y3 <=     A0 and     A1 and not A2;
	Y4 <= not A0 and not A1 and     A2;
	Y5 <=     A0 and not A1 and     A2;
	Y6 <= not A0 and     A1 and     A2;
	Y7 <=     A0 and     A1 and     A2;

	LED_1 <= Y0;
	LED_2 <= Y1;
	LED_3 <= Y2;
	LED_4 <= Y3;
	LED_5 <= Y4;
	LED_6 <= Y5;
	LED_7 <= Y6;
	LED_8 <= Y7;
	
end RTL;
