-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- 7Segment Decode circuit
-----------------------------------------------------------
-- File   : decode_7seg_vhdl_top.vhd
-- Date   : 2007-08-07
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity decode_7seg_vhdl_top is
	port(
		LED_A	:	out std_logic;
		LED_B	:	out std_logic;
		LED_C	:	out std_logic;
		LED_D	:	out std_logic;
		LED_E	:	out std_logic;
		LED_F	:	out std_logic;
		LED_G	:	out std_logic;
		LED_DP	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end decode_7seg_vhdl_top;

architecture RTL of decode_7seg_vhdl_top is

	signal number	:	std_logic_vector(2 downto 0);

begin

	number(2) <= not SW7;
	number(1) <= not SW6;
	number(0) <= not SW5;

	LED_A <= '1' when number = 0 else
	         '0' when number = 1 else
	         '1' when number = 2 else
	         '1' when number = 3 else
	         '0' when number = 4 else
	         '1' when number = 5 else
	         '1' when number = 6 else
	         '1' when number = 7 else
	         '0';

	LED_B <= '1' when number = 0 else
	         '1' when number = 1 else
	         '1' when number = 2 else
	         '1' when number = 3 else
	         '1' when number = 4 else
	         '0' when number = 5 else
	         '0' when number = 6 else
	         '1' when number = 7 else
	         '0';

	LED_C <= '1' when number = 0 else
	         '1' when number = 1 else
	         '0' when number = 2 else
	         '1' when number = 3 else
	         '1' when number = 4 else
	         '1' when number = 5 else
	         '1' when number = 6 else
	         '1' when number = 7 else
	         '0';

	LED_D <= '1' when number = 0 else
	         '0' when number = 1 else
	         '1' when number = 2 else
	         '1' when number = 3 else
	         '0' when number = 4 else
	         '1' when number = 5 else
	         '1' when number = 6 else
	         '0' when number = 7 else
	         '0';

	LED_E <= '1' when number = 0 else
	         '0' when number = 1 else
	         '1' when number = 2 else
	         '0' when number = 3 else
	         '0' when number = 4 else
	         '0' when number = 5 else
	         '1' when number = 6 else
	         '0' when number = 7 else
	         '0';

	LED_F <= '1' when number = 0 else
	         '0' when number = 1 else
	         '0' when number = 2 else
	         '0' when number = 3 else
	         '1' when number = 4 else
	         '1' when number = 5 else
	         '1' when number = 6 else
	         '0' when number = 7 else
	         '0';

	LED_G <= '0' when number = 0 else
	         '0' when number = 1 else
	         '1' when number = 2 else
	         '1' when number = 3 else
	         '1' when number = 4 else
	         '1' when number = 5 else
	         '1' when number = 6 else
	         '0' when number = 7 else
	         '0';

	LED_DP <= '0' when number = 0 else
	          '0' when number = 1 else
	          '0' when number = 2 else
	          '0' when number = 3 else
	          '0' when number = 4 else
	          '0' when number = 5 else
	          '0' when number = 6 else
	          '0' when number = 7 else
	          '0';

end RTL;
