-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- Delay Flip Flop with Clear Circuit
-----------------------------------------------------------
-- File   : dff_clrn_2_vhdl_top.vhd
-- Date   : 2009-06-08
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity dff_clrn_2_vhdl_top is
	port(
		CLKIN	:	in std_logic;
		LED1	:	out std_logic;
		LED2	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end dff_clrn_2_vhdl_top;

architecture RTL of dff_clrn_2_vhdl_top is

	signal div_cnt		:	std_logic_vector(23 downto 0);
	signal div_clk_sw	:	std_logic;
	signal sw			:	std_logic_vector(2 downto 0);

	signal D			:	std_logic;
	signal CLK			:	std_logic;
	signal CLRN			:	std_logic;
	signal Q			:	std_logic;
	signal QN			:	std_logic;

begin

	process(CLKIN)
	begin
		if(CLKIN'event and CLKIN='1') then
			div_cnt <= div_cnt + 1;
		end if;
	end process;
	div_clk_sw <= div_cnt(16);

	process(div_clk_sw)
	begin
		if(div_clk_sw'event and div_clk_sw='1') then
			sw(0) <= SW5;
			sw(1) <= SW6;
			sw(2) <= SW7;
		end if;
	end process;

	D    <= sw(0);
	CLK  <= sw(1);
	CLRN <= sw(2);

	process(CLK,CLRN)
	begin
		if(CLRN='0') then
			Q <= '0';
		elsif(CLK'event and CLK='1') then
			Q <= D;
		end if;
	end process;
	QN <= not Q;
	
	LED1  <= Q;
	LED2  <= QN;
	
end RTL;
