-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- Full Adder Circuit
-----------------------------------------------------------
-- File   : full_adder_vhdl_top.vhd
-- Date   : 2009-06-03
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity full_adder_vhdl_top is
	port(
		LED_S	:	out std_logic;
		LED_CO	:	out std_logic;
		SW5		:	in std_logic;
		SW6		:	in std_logic;
		SW7		:	in std_logic
	);
end full_adder_vhdl_top;

architecture RTL of full_adder_vhdl_top is

	signal A	:	std_logic;
	signal B	:	std_logic;
	signal CI	:	std_logic;
	signal S	:	std_logic;
	signal CO	:	std_logic;

begin

	A  <= not SW5;
	B  <= not SW6;
	CI <= not SW7;

	S  <= (CI and not A and not B) or (not CI and A and not B) or (not CI and not A and B) or (CI and A and B);
	CO <= (CI and A and not B) or (CI and not A and B) or (not CI and A and B) or (CI and A and B);

	LED_S  <= S;
	LED_CO <= CO;
	
end RTL;
