-----------------------------------------------------------
-- FPGA Training Board(B6101)
-- 7Segment LED Controller
-----------------------------------------------------------
-- File   : micom_7seg_vhdl_top.vhd
-- Date   : 2007-11-14
-- Family : Cyclone
-- Device : EP1C3T144C8
--
-- Designed by TOYO-LINX Co.,Ltd. / yKikuchi
-----------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity micom_7seg_vhdl_top is
	port(
		D		:	in std_logic_vector(7 downto 0);
		A0		:	in std_logic;
		WR_N	:	in std_logic;
		CS_N	:	in std_logic;
		LED1A	:	out std_logic;
		LED1B	:	out std_logic;
		LED1C	:	out std_logic;
		LED1D	:	out std_logic;
		LED1E	:	out std_logic;
		LED1F	:	out std_logic;
		LED1G	:	out std_logic;
		LED1DP	:	out std_logic;
		LED2A	:	out std_logic;
		LED2B	:	out std_logic;
		LED2C	:	out std_logic;
		LED2D	:	out std_logic;
		LED2E	:	out std_logic;
		LED2F	:	out std_logic;
		LED2G	:	out std_logic;
		LED2DP	:	out std_logic
	);
end micom_7seg_vhdl_top;

architecture RTL of micom_7seg_vhdl_top is

	signal led1	:	std_logic_vector(7 downto 0);
	signal led2	:	std_logic_vector(7 downto 0);

begin
	process(WR_N)
	begin
		if(WR_N'event and WR_N = '1')then
			if(CS_N = '0')then
				if(A0 = '0')then
					led2 <= D;
				else
					led1 <= D;
				end if;
			end if;
		end if;
	end process;

	LED1A  <= led1(0);
	LED1B  <= led1(1);
	LED1C  <= led1(2);
	LED1D  <= led1(3);
	LED1E  <= led1(4);
	LED1F  <= led1(5);
	LED1G  <= led1(6);
	LED1DP <= led1(7);
	LED2A  <= led2(0);
	LED2B  <= led2(1);
	LED2C  <= led2(2);
	LED2D  <= led2(3);
	LED2E  <= led2(4);
	LED2F  <= led2(5);
	LED2G  <= led2(6);
	LED2DP <= led2(7);

end RTL;
