/***********************************************************************/
/*                                                                     */
/*  FILE        :prog02_7seg.c                                         */
/*  DATE        :Fri, Nov 16, 2007                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		// H8L̖߂g
#include	"iodefine.h"	// I/Õx`

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/
//\f[^
const unsigned char SegLedData[][2] = {
	{0x01,0x00},{0x02,0x00},{0x04,0x00},{0x08,0x00},	// 0, 1, 2, 3
	{0x10,0x00},{0x20,0x00},{0x01,0x00},{0x00,0x01},	// 4, 5, 6, 7
	{0x00,0x02},{0x00,0x04},{0x00,0x08},{0x00,0x10},	// 8, 9,10,11
	{0x00,0x20},{0x00,0x01},{0x00,0x02},{0x00,0x04},	//12,13,14,15
	{0x00,0x08},{0x08,0x00},{0x10,0x00},{0x40,0x00},	//16,17,18,19
	{0x00,0x40},{0x00,0x02},{0x00,0x01},{0x01,0x00},	//20,21,22,23
	{0x20,0x00},{0x40,0x00},{0x00,0x40},{0x00,0x04},	//24,25,26,27
	{0x00,0x08},{0x08,0x00},{0x10,0x00},{0x20,0x00}		//28,29,30,31
};

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// LED\Ɋ֌Wϐ ------------------------------------------------
unsigned long	SegLedBuf[2];	//\obt@

/************************************************************************
	֐̒`
************************************************************************/
void		init_io(void);
void		main(void);
void		set_7segLED_cont(void);
void		wait(void);

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	unsigned char i;
	
	init_io();	// I/O|[gCjVCY
	
	while(1){
		for (i=0; i<32; i++){
			SegLedBuf[0] = SegLedData[i][0];
			SegLedBuf[1] = SegLedData[i][1];
			set_7segLED_cont();
			wait();
		}
	}	
}

/************************************************************************
	7ZOgLEDRg[ɕ\f[^Zbg
************************************************************************/
void set_7segLED_cont(void)
{
	unsigned char i;
	unsigned int d;

	d = SegLedBuf[0] * 0x0100 + SegLedBuf[1];
	
	IO.PDR6.BIT.B2 = 1;	//CS = High
	
	for (i=0; i<16; i++){
		if ((d & 0x0001)==0x0001)	{IO.PDR6.BIT.B0 = 1;}	//DATA Set
		else						{IO.PDR6.BIT.B0 = 0;}
		IO.PDR6.BIT.B1 = 1;	//SCLK = High
		IO.PDR6.BIT.B1 = 0;	//SCLK = Low
		d = d / 2;	//EVtg
	}
	
	IO.PDR6.BIT.B2 = 0;	//CS = Low
}

/************************************************************************
	I/O|[g CjVCY
************************************************************************/
void init_io(void)
{
	IO.PCR6			=	0x07;	//|[g6,P60-62o,P63-67
	IO.PDR6.BYTE	=	0x00;
}

/************************************************************************
	EFCg
************************************************************************/
void wait(void)
{
	unsigned long i;

	for (i=0;i<400000;i++){}
}
